/**
 * Document interface
 */
export interface Document {
    /**
     * The uri of a document
     */
    uri: string;
    /**
     * The text contained within a document
     */
    text: string;
}
/**
 * A small set of functionality for loading files and directory of files
 */
export declare class DocumentLoader {
    constructor();
    /**
     * Load a file from a given path
     * @param path the system path
     */
    load(path: string): Promise<string>;
    /**
     * Load a collection of documents from a given directory
     * @param path the path of the directory
     */
    loadDirectory(path: string): AsyncIterableIterator<Document>;
}
